/*
 *    This file is part of ACADO Toolkit.
 *
 *    ACADO Toolkit -- A Toolkit for Automatic Control and Dynamic Optimization.
 *    Copyright (C) 2008-2014 by Boris Houska, Hans Joachim Ferreau,
 *    Milan Vukov, Rien Quirynen, KU Leuven.
 *    Developed within the Optimization in Engineering Center (OPTEC)
 *    under supervision of Moritz Diehl. All rights reserved.
 *
 *    ACADO Toolkit is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 3 of the License, or (at your option) any later version.
 *
 *    ACADO Toolkit is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with ACADO Toolkit; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


/**
 *    \file include/code_generation/linear_solvers/code_generation.hpp
 *    \author Rien Quirynen
 *    \date 2012
 */

#ifndef ACADO_TOOLKIT_LINEAR_SOLVER_GENERATION_HPP
#define ACADO_TOOLKIT_LINEAR_SOLVER_GENERATION_HPP


// LIST OF HEADER FILES:
// -----------------------------------------------------

   #include <acado/code_generation/linear_solvers/linear_solver_export.hpp>
   #include <acado/code_generation/linear_solvers/irk_3stage_simplified_newton_export.hpp>
   #include <acado/code_generation/linear_solvers/irk_4stage_simplified_newton_export.hpp>
   #include <acado/code_generation/linear_solvers/irk_3stage_single_newton_export.hpp>
   #include <acado/code_generation/linear_solvers/irk_4stage_single_newton_export.hpp>
   #include <acado/code_generation/linear_solvers/gaussian_elimination_export.hpp>
   #include <acado/code_generation/linear_solvers/householder_qr_export.hpp>

// -----------------------------------------------------


#endif  // ACADO_TOOLKIT_LINEAR_SOLVER_GENERATION_HPP
