/*
 *    This file is part of ACADO Toolkit.
 *
 *    ACADO Toolkit -- A Toolkit for Automatic Control and Dynamic Optimization.
 *    Copyright (C) 2008-2014 by Boris Houska, Hans Joachim Ferreau,
 *    Milan Vukov, Rien Quirynen, KU Leuven.
 *    Developed within the Optimization in Engineering Center (OPTEC)
 *    under supervision of Moritz Diehl. All rights reserved.
 *
 *    ACADO Toolkit is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 3 of the License, or (at your option) any later version.
 *
 *    ACADO Toolkit is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with ACADO Toolkit; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */



/**
 *    \file include/acado/function/function.hpp
 *    \author Hans Joachim Ferreau, Boris Houska
 *    \date 31.05.2008
 */

#ifndef ACADO_TOOLKIT_FUNCTION_HPP
#define ACADO_TOOLKIT_FUNCTION_HPP

#include <acado/matrix_vector/matrix_vector.hpp>

#include <acado/symbolic_expression/acado_syntax.hpp>
#include <acado/symbolic_expression/symbolic_expression.hpp>

#include <acado/function/evaluation_point.hpp>
#include <acado/function/t_evaluation_point.hpp>
#include <acado/function/function_.hpp>
#include <acado/function/c_function.hpp>
#include <acado/function/differential_equation.hpp>
#include <acado/function/transition.hpp>
#include <acado/function/output_fcn.hpp>

#endif  // ACADO_TOOLKIT_FUNCTION_HPP
